Wprowadzenie

Grupowanie polega na przypisanie obiektw do okrelonych grup/klastrw/skupie/segmentw, 
w ktrych znajd si jednostki najbardziej do siebie podobne,
a powstae grupy bd si midzy sob rni. 
Cae utrudnienie polega na tym, e nie wiemy ile tych grup ma powsta.


Metoda k-rednich
Najpopularniejsz metod grupowania jest metoda k-rednich. 
Do jej zalet naley zaliczy to, e dobrze dziaa zarwno na maych, 
jak i duych zbiorach i jest bardzo efektywny - zwykle osiga zbieno w mniej ni 10 iteracjach. 
Z wad naley wskaza losowy wybr pocztkowych centrw skupie, 
co moe skutkowa nieprawidowym przypisaniem obiektw do grup.


Algorytm postpowania jest nastpujcy:
  
1.Wska liczb grup k
2.Wybierz dowolne  k punktw jako centra grup.
3. Przypisz kad z obserwacji do najbliszego centroidu.
4 Oblicz nowe centrum grupy.
5. Przypisz kad z obserwacji do nowych centroidw. 
Jeli ktra obserwacja zmienia grup - przejd do kroku nr 4,
a w przeciwnym przypadku zakocz algorytm.


Wykorzystamy informacje ze zbioru zawierajcego informacje
o klientach sklepu i dokonamy grupowania tych klientw.

Opis zbioru:
  
klientID - identyfikator klienta
plec - pe
wiek - wiek
roczny_dochod - roczny dochd wyraony w tys. dolarw
wskaznik_wydatkow - klasyfikacja sklepu od 1 do 100

Wczytujemy zbir danych i sprawdzamy czy pomidzy zmiennymi s widoczne jakie zalenoci.


library(tidyverse)

klienci <- read.csv("klienci.csv")

ggplot(klienci, aes(x=wiek, y=roczny_dochod)) +
  geom_point()


# Pomidzy wiekiem a rocznym dochodem nie wida zalenoci.


ggplot(klienci, aes(x=wiek, y=wskaznik_wydatkow)) +
  geom_point()

# W przypadku wieku i wskanika wydatkw moglibymy si pokusi o podzia zbioru na dwie grupy za pomoc przektnej.

ggplot(klienci, aes(x=wskaznik_wydatkow, y=roczny_dochod)) +
  geom_point()


#Po zestawieniu rocznego dochodu i wskanika wydatkw wyania si 5 potencjalnych grup, 
#zatem te dwie cechy wykorzystamy do grupowania. 
#Jednak przed zastosowaniem algorytmu musimy te dane przygotowa
#normalizujc zakres obu cech - w tym przypadku za pomoc standaryzacji.

klienci_z <- klienci %>%
  select(roczny_dochod, wskaznik_wydatkow) %>%
  scale()

head(klienci_z)




W przypadku, gdy podzia na grupy nie jest tak oczywisty 
lub bierzemy pod uwag wicej ni dwa kryteria to 
wwczas w wyznaczeniu optymalnej liczby skupie moe pomc wykres osypiska 
(ang. elbow method).

Polega to na przeprowadzeniu grupowania (z wykorzystaniem funkcji kmeans())
dla rniej liczby grup i porwnanie wariancji wewntrz-grupowej. 
Dane do stworzenia wykresu osypiska moemy obliczy w ptli:
  
  zm_w_gr <- numeric(15)

# wprowadzenie ptli

for(i in 1:length(zm_w_gr)) {
  set.seed(14)
  gr <- kmeans(klienci_z, centers = i)
  zm_w_gr[i] <- gr$tot.withinss
}

plot(1:15, zm_w_gr, type="b")


Wybieramy liczb skupie po ktrej nie nastpuje ju gwatowny
spadek wartoci wariancji wewntrz-grupowej. 
Wedug tego kryterium powinnimy wybra warto 6 lub 5. 
Sprawdmy zatem jakie otrzymamy przyporzdkowanie do grup. 
Nastpnie informacj o tym przypisaniu umieszczamy w oryginalnym zbiorze danych
i przedstawiamy na wykresie. 
W celu uzyskania powtarzalnych wynikw zastosujemy stae ziarno generatora.


set.seed(12)

grupy <- kmeans(x = klienci_z, centers = 5)

klienci$grupa <- as.factor(grupy$cluster)

ggplot(klienci, aes(x=wskaznik_wydatkow, 
                    y=roczny_dochod,
                    color=grupa)) +
  geom_point()

Jak zauwaamy ten podzia nie jest waciwy. 
Ze wzgldu na losowy przydzia centrw skupie na pocztku
algorytmu istnieje spora szansa, 
e rozwizanie nie bdzie optymalne. 
Rozwizaniem tego problemu jest uycie algorytmu kmeans++ 
do pocztkowego ustalenia centrw. Ta metoda jest zaimplementowana w pakiecie ClusterR. 
Ponadto jest tam take funkcja do ustalenia optymalnej liczby skupie na podstawie wykresu osypiska.

library(ClusterR)

Optimal_Clusters_KMeans(data = klienci_z, max_clusters = 15, criterion = "WCSSE")



Wybieramy liczb skupie po ktrej nie nastpuje ju gwatowny spadek wartoci wariancji wewntrz-grupowej.
W analizowanym przypadku bdzie to 5 grup.

Dodatkowo mona obliczy jedno z wielu kryteriw dobroci podziau obiektw na grupy. 
Jednym z najpopularniejszych jest kryterium Caliskiego-Harabasza 
zaimplementowane m.in. w pakiecie clusterCrit. 
Podobnie jak w przypadku wykresu osypiska naley policzy warto tego kryterium 
dla rnej liczby segemntw i wybra liczb grup wskazan przez warto maksymaln.

library(clusterCrit)

kryt_ch <- numeric(15)

for(i in 1:length(kryt_ch)) {
  gr <- KMeans_rcpp(klienci_z, clusters = i)
  kryt_ch[i] <- intCriteria(traj = klienci_z, part = as.integer(gr$clusters), crit = "cal")
}

plot(1:15, kryt_ch, type="b")



serwujemy dla 5 i 9 skupie. Naley jednak pamita, 
e w grupowaniu bardzo wana jest ocena badacza pod ktem sensownoci otrzymanego podziau 
atwiej stworzy 5 rnych kampanii reklamowych anieli 9.

Nastpnie korzystamy z funkcji KMeans_rcpp do wyznaczenia przynalenoci do grup. 
Ta funkcja domylnie korzysta z algorytmu kmeans++,
zatem nie ma niebezpieczestwa, e uzyskamy niewaciwe przyporzdkowanie.

grupy2 <- KMeans_rcpp(data = klienci_z, clusters = 5)

klienci$grupa2 <- as.factor(grupy2$clusters)

ggplot(klienci, aes(x=wskaznik_wydatkow, 
                    y=roczny_dochod,
                    color=grupa2)) +
  geom_point()


Ostatnim etapem analizy jest odpowiednia charakterystyka uzyskanych klastrw -
najczciej wyznacza si rednie wartoci cech w ramach kadej grupy.

klienci %>%
  select(-klientID, -plec, -grupa) %>%
  group_by(grupa2) %>%
  summarise_all(.funs = "mean")


W grupie pierwszej znalazy si osoby z niskimi dochodami i wysokim wskanikiem wydatkw. 
Grupa druga to klienci o niskich dochodach i wydatkach - 
ich przeciwiestwem jest grupa 4. W grupie 3 s osoby z wysokimi dochodami, 
ale niskimi wydatkami. Grupa 5 to z kolei redniacy - klienci o rednich dochodach i wydatkach.